diff --git a/src/libsystemd/sd-journal/journal-file.c b/src/libsystemd/sd-journal/journal-file.c
index b51bbf5..87c6e50 100644
--- a/src/libsystemd/sd-journal/journal-file.c
+++ b/src/libsystemd/sd-journal/journal-file.c
@@ -602,6 +602,8 @@ static uint64_t minimum_header_size(Object *o) {
                 [OBJECT_FIELD_HASH_TABLE] = sizeof(HashTableObject),
                 [OBJECT_ENTRY_ARRAY] = sizeof(EntryArrayObject),
                 [OBJECT_TAG] = sizeof(TagObject),
+                [OBJECT_TRIE_NODE] = sizeof(TrieNodeObject),
+                [OBJECT_TRIE_HASH_TABLE] = sizeof(HashTableObject),
         };
 
         if (o->object.type >= ELEMENTSOF(table) || table[o->object.type] <= 0)
@@ -667,19 +669,37 @@ static int journal_file_check_object(JournalFile *f, uint64_t offset, Object *o)
                 uint64_t sz;
 
                 sz = le64toh(READ_NOW(o->object.size));
-                if (sz < offsetof(EntryObject, items) ||
-                    (sz - offsetof(EntryObject, items)) % sizeof(EntryItem) != 0)
-                        return log_debug_errno(SYNTHETIC_ERRNO(EBADMSG),
-                                               "Bad entry size (<= %zu): %" PRIu64 ": %" PRIu64,
-                                               offsetof(EntryObject, items),
-                                               sz,
-                                               offset);
+                if (JOURNAL_HEADER_COMPACT(f->header)) {
+                        if (sz != sizeof(EntryObject))
+                                return log_debug_errno(
+                                        SYNTHETIC_ERRNO(EBADMSG),
+                                        "Bad entry size (<= %zu): %" PRIu64 ": %" PRIu64,
+                                        sizeof(EntryObject),
+                                        sz,
+                                        offset);
 
-                if ((sz - offsetof(EntryObject, items)) / sizeof(EntryItem) <= 0)
-                        return log_debug_errno(SYNTHETIC_ERRNO(EBADMSG),
-                                               "Invalid number items in entry: %" PRIu64 ": %" PRIu64,
-                                               (sz - offsetof(EntryObject, items)) / sizeof(EntryItem),
-                                               offset);
+                        if (o->entry.trie_offset == 0)
+                                return log_debug_errno(
+                                        SYNTHETIC_ERRNO(EBADMSG),
+                                        "Bad entry trie offset (== 0): %" PRIu64,
+                                        offset);
+                } else {
+                        if (sz < offsetof(EntryObject, items) ||
+                            (sz - offsetof(EntryObject, items)) % sizeof(EntryItem) != 0)
+                                return log_debug_errno(
+                                        SYNTHETIC_ERRNO(EBADMSG),
+                                        "Bad entry size (<= %zu): %" PRIu64 ": %" PRIu64,
+                                        offsetof(EntryObject, items),
+                                        sz,
+                                        offset);
+
+                        if ((sz - offsetof(EntryObject, items)) / sizeof(EntryItem) <= 0)
+                                return log_debug_errno(
+                                        SYNTHETIC_ERRNO(EBADMSG),
+                                        "Invalid number items in entry: %" PRIu64 ": %" PRIu64,
+                                        (sz - offsetof(EntryObject, items)) / sizeof(EntryItem),
+                                        offset);
+                }
 
                 if (le64toh(o->entry.seqnum) <= 0)
                         return log_debug_errno(SYNTHETIC_ERRNO(EBADMSG),
@@ -703,7 +723,8 @@ static int journal_file_check_object(JournalFile *f, uint64_t offset, Object *o)
         }
 
         case OBJECT_DATA_HASH_TABLE:
-        case OBJECT_FIELD_HASH_TABLE: {
+        case OBJECT_FIELD_HASH_TABLE:
+        case OBJECT_TRIE_HASH_TABLE: {
                 uint64_t sz;
 
                 sz = le64toh(READ_NOW(o->object.size));
@@ -711,10 +732,9 @@ static int journal_file_check_object(JournalFile *f, uint64_t offset, Object *o)
                     (sz - offsetof(HashTableObject, items)) % sizeof(HashItem) != 0 ||
                     (sz - offsetof(HashTableObject, items)) / sizeof(HashItem) <= 0)
                         return log_debug_errno(SYNTHETIC_ERRNO(EBADMSG),
-                                               "Invalid %s hash table size: %" PRIu64 ": %" PRIu64,
-                                               o->object.type == OBJECT_DATA_HASH_TABLE ? "data" : "field",
-                                               sz,
-                                               offset);
+                                               "Invalid %s size: %" PRIu64 ": %" PRIu64,
+                                               journal_object_type_to_string(o->object.type),
+                                               sz, offset);
 
                 break;
         }
@@ -754,6 +774,26 @@ static int journal_file_check_object(JournalFile *f, uint64_t offset, Object *o)
                                                le64toh(o->tag.epoch), offset);
 
                 break;
+
+        case OBJECT_TRIE_NODE:
+                if (le64toh(o->object.size) != sizeof(TrieNodeObject))
+                        return log_debug_errno(
+                                SYNTHETIC_ERRNO(EBADMSG),
+                                "Invalid object trie node size: %" PRIu64,
+                                le64toh(o->object.size));
+
+                if (!VALID64(le64toh(o->trie_node.next_hash_offset)) ||
+                    !VALID64(le32toh(o->trie_node.object_offset)) ||
+                    !VALID64(le32toh(o->trie_node.parent_offset)))
+                        return log_debug_errno(
+                                SYNTHETIC_ERRNO(EBADMSG),
+                                "Invalid offset (next_hash_offset=" OFSfmt ", object_offset=" OFSfmt32
+                                ", parent_offset=" OFSfmt32,
+                                le64toh(o->trie_node.next_hash_offset),
+                                le32toh(o->trie_node.object_offset),
+                                le32toh(o->trie_node.parent_offset));
+
+                break;
         }
 
         return 0;
@@ -966,6 +1006,20 @@ int journal_file_append_object(
         return 0;
 }
 
+static int default_data_hash_table_size(JournalFile *f) {
+        uint64_t s;
+
+        /* We estimate that we need 1 hash table entry per 768 bytes of journal file and we want to make sure
+         * we never get beyond 75% fill level. Calculate the hash table size for the maximum file size based
+         * on these metrics. */
+
+        s = (f->metrics.max_size * 4 / 768 / 3) * sizeof(HashItem);
+        if (s < DEFAULT_DATA_HASH_TABLE_SIZE)
+                s = DEFAULT_DATA_HASH_TABLE_SIZE;
+
+        return s;
+}
+
 static int journal_file_setup_data_hash_table(JournalFile *f) {
         uint64_t s, p;
         Object *o;
@@ -974,14 +1028,7 @@ static int journal_file_setup_data_hash_table(JournalFile *f) {
         assert(f);
         assert(f->header);
 
-        /* We estimate that we need 1 hash table entry per 768 bytes
-           of journal file and we want to make sure we never get
-           beyond 75% fill level. Calculate the hash table size for
-           the maximum file size based on these metrics. */
-
-        s = (f->metrics.max_size * 4 / 768 / 3) * sizeof(HashItem);
-        if (s < DEFAULT_DATA_HASH_TABLE_SIZE)
-                s = DEFAULT_DATA_HASH_TABLE_SIZE;
+        s = default_data_hash_table_size(f);
 
         log_debug("Reserving %"PRIu64" entries in data hash table.", s / sizeof(HashItem));
 
@@ -1029,6 +1076,48 @@ static int journal_file_setup_field_hash_table(JournalFile *f) {
         return 0;
 }
 
+static int journal_file_setup_trie_hash_table(JournalFile *f) {
+        uint64_t s, p;
+        Object *o;
+        int r;
+
+        assert(f);
+        assert(f->header);
+
+        /* Based on the following results from converting a non-compact system journal to compact mode, we
+         * use "1.5 * default data hash table size" as the default trie hash table size.
+         *
+         * OBJECT TYPE      ENTRIES SIZE
+         * Unused           0       0B
+         * Data             963284  89.8M
+         * Field            2544    137.2K
+         * Entry            3269815 574.1M
+         * Data Hash Table  11      39.1M
+         * Field Hash Table 11      57.4K
+         * Entry Array      458484  539.1M
+         * Tag              0       0B
+         * Trie Node        1660978 76.0M
+         * Trie Hash Table  11      39.1M
+         * Boot ID          58      1.8K
+         */
+        s = default_data_hash_table_size(f);
+        s += ALIGN_TO(s / 2, sizeof(HashItem));
+
+        log_debug("Reserving %"PRIu64" entries in trie hash table.", s / sizeof(HashItem));
+
+        r = journal_file_append_object(
+                f, OBJECT_TRIE_HASH_TABLE, offsetof(Object, hash_table.items) + s, &o, &p);
+        if (r < 0)
+                return r;
+
+        memzero(o->hash_table.items, s);
+
+        f->header->trie_hash_table_offset = htole64(p + offsetof(Object, hash_table.items));
+        f->header->trie_hash_table_size = htole64(s);
+
+        return 0;
+}
+
 int journal_file_map_data_hash_table(JournalFile *f) {
         uint64_t s, p;
         void *t;
@@ -1081,6 +1170,29 @@ int journal_file_map_field_hash_table(JournalFile *f) {
         return 0;
 }
 
+static int journal_file_map_trie_hash_table(JournalFile *f) {
+        uint64_t s, p;
+        void *t;
+        int r;
+
+        assert(f);
+        assert(f->header);
+
+        if (f->trie_hash_table)
+                return 0;
+
+        p = le64toh(f->header->trie_hash_table_offset);
+        s = le64toh(f->header->trie_hash_table_size);
+
+        r = journal_file_move_to(f, OBJECT_TRIE_HASH_TABLE, true, p, s, &t);
+        if (r < 0)
+                return r;
+
+        f->trie_hash_table = t;
+        return 0;
+}
+
+
 static int journal_file_link_field(
                 JournalFile *f,
                 Object *o,
@@ -1177,6 +1289,52 @@ static int journal_file_link_data(
         return 0;
 }
 
+static int journal_file_link_trie_node(
+                JournalFile *f,
+                Object *o,
+                uint64_t offset,
+                uint64_t hash) {
+
+        uint64_t p, h, m;
+        int r;
+
+        assert(f);
+        assert(f->header);
+        assert(o);
+        assert(offset > 0);
+
+        if (o->object.type != OBJECT_TRIE_NODE)
+                return -EINVAL;
+
+        m = le64toh(READ_NOW(f->header->trie_hash_table_size)) / sizeof(HashItem);
+        if (m <= 0)
+                return -EBADMSG;
+
+        /* This might alter the window we are looking at */
+        o->trie_node.next_hash_offset = 0;
+
+        h = hash % m;
+        p = le64toh(f->trie_hash_table[h].tail_hash_offset);
+        if (p == 0)
+                /* Only entry in the hash table is easy */
+                f->trie_hash_table[h].head_hash_offset = htole64(offset);
+        else {
+                /* Move back to the previous data object, to patch in
+                 * pointer */
+
+                r = journal_file_move_to_object(f, OBJECT_TRIE_NODE, p, &o);
+                if (r < 0)
+                        return r;
+
+                o->trie_node.next_hash_offset = htole64(offset);
+        }
+
+        f->trie_hash_table[h].tail_hash_offset = htole64(offset);
+        f->header->n_trie_nodes = htole64(le64toh(f->header->n_trie_nodes) + 1);
+
+        return 0;
+}
+
 static int next_hash_offset(
                 JournalFile *f,
                 uint64_t *p,
@@ -1578,6 +1736,43 @@ static int journal_file_append_data(
         return 0;
 }
 
+static int journal_file_append_trie_node(
+                JournalFile *f,
+                uint64_t hash,
+                uint64_t parent_offset,
+                uint64_t object_offset,
+                Object **ret,
+                uint64_t *ret_offset) {
+
+        Object *o;
+        uint64_t p;
+        int r;
+
+        /* Map the trie hash table, if it isn't mapped yet. */
+        r = journal_file_map_trie_hash_table(f);
+        if (r < 0)
+                return r;
+
+        r = journal_file_append_object(f, OBJECT_TRIE_NODE, sizeof(TrieNodeObject), &o, &p);
+        if (r < 0)
+                return r;
+
+        o->trie_node.hash = htole64(hash);
+        o->trie_node.parent_offset = htole32(parent_offset);
+        o->trie_node.object_offset = htole32(object_offset);
+
+        r = journal_file_link_trie_node(f, o, p, hash);
+        if (r < 0)
+                return r;
+
+        if (ret)
+                *ret = o;
+        if (ret_offset)
+                *ret_offset = p;
+
+        return 0;
+}
+
 static int maybe_decompress_payload(
                 JournalFile *f,
                 uint8_t *payload,
@@ -1673,7 +1868,7 @@ int journal_file_data_payload(
                 ret_size);
 }
 
-int journal_file_entry_item_next(
+static int journal_file_entry_item_next_compact(
                 JournalFile *f,
                 Object *e,
                 uint64_t offset,
@@ -1685,42 +1880,82 @@ int journal_file_entry_item_next(
                 void **ret_data,
                 size_t *ret_size) {
 
-        /* Iterates over the entry items of the given entry. The output parameters return data about the Data
-         * object pointed at by the next entry item if requested.
-         *
-         * - If `ret_offset` is not NULL, it is set to the offset of the Data object
-         * - If `ret_data` is not NULL, it is set to a pointer to the decompressed payload of the Data object
-         * - If `ret_size` is not NULL, it is set to the size of the decompressed payload of the Data object
-         *
-         * The iterator is stored in `i`. To start iterating from the start of the entry items, set `i` to
-         * zero. It is automatically updated by this function and should not be touched again unless you want
-         * to restart iterating over the entry items.
-         *
-         * If `field` and `field_length` are given, this function keeps iterating until it finds an entry
-         * item whose Data object payload starts with the given field, followed by the '=' character.
-         *
-         * If `data_threshold` is larger than zero, the decompressed payload is limited to `data_threshold`
-         * amount of bytes.
-         *
-         * This function returns a positive number if it succesfully managed to find the next entry item. If
-         * no more entry items were available, or none of the remaining entry items were of the given field,
-         * it returns zero. If an error occurred, it returns a negative errno value.
-         */
-
-        uint64_t p, sz;
+        uint64_t p;
         int r;
 
-        assert(!e || e->object.type == OBJECT_ENTRY);
-        assert(offset);
-        assert(i);
-        assert(!field == (field_length == 0)); /* These must be specified together. */
+        if (*i == UINT64_MAX)
+                return 0;
 
-        if (!e) {
-                r = journal_file_move_to_object(f, OBJECT_ENTRY, offset, &e);
+        p = *i == 0 ? le64toh(e->entry.trie_offset) : *i;
+        if (p == 0)
+                return -EBADMSG;
+
+        for (; p != 0;) {
+                Object *o;
+                uint64_t q;
+
+                r = journal_file_move_to_object(f, OBJECT_TRIE_NODE, p, &o);
+                if (IN_SET(r, -EADDRNOTAVAIL, -EBADMSG)) {
+                        log_debug_errno(r, "Bad trie node at %"PRIu64", skipping remaining entry items: %m", p);
+                        break;
+                }
+                if (r < 0)
+                        return r;
+
+                p = le32toh(o->trie_node.parent_offset);
+                q = le32toh(o->trie_node.object_offset);
+
+                r = journal_file_data_payload(
+                        f,
+                        NULL,
+                        q,
+                        field,
+                        field_length,
+                        data_threshold,
+                        ret_data,
+                        ret_size);
+                if (IN_SET(r, -EADDRNOTAVAIL, -EBADMSG)) {
+                        log_debug_errno(r, "Entry item %"PRIu64" data object is bad, skipping over it: %m", q);
+                        continue;
+                }
                 if (r < 0)
                         return r;
+                if (r == 0)
+                        continue;
+
+                if (ret_offset)
+                        *ret_offset = q;
+
+                /* If we've iterated all trie nodes, set the iterator to UINT64_MAX to indicate this. We
+                * can't use zero as zero is reserved for starting iteration from the beginning. */
+                if (p == 0)
+                        p = UINT64_MAX;
+
+                *i = p;
+
+                return 1;
         }
 
+        *i = UINT64_MAX;
+
+        return 0;
+}
+
+static int journal_file_entry_item_next_non_compact(
+                JournalFile *f,
+                Object *e,
+                uint64_t offset,
+                uint64_t *i,
+                const char *field,
+                size_t field_length,
+                size_t data_threshold,
+                uint64_t *ret_offset,
+                void **ret_data,
+                size_t *ret_size) {
+
+        uint64_t p, sz;
+        int r;
+
         sz = le64toh(READ_NOW(e->object.size));
         if (sz < offsetof(Object, entry.items))
                 return -EBADMSG;
@@ -1754,6 +1989,60 @@ int journal_file_entry_item_next(
         return 0;
 }
 
+int journal_file_entry_item_next(
+                JournalFile *f,
+                Object *e,
+                uint64_t offset,
+                uint64_t *i,
+                const char *field,
+                size_t field_length,
+                size_t data_threshold,
+                uint64_t *ret_offset,
+                void **ret_data,
+                size_t *ret_size) {
+
+        /* Iterates over the entry items of the given entry. The output parameters return data about the Data
+         * object pointed at by the next entry item if requested.
+         *
+         * - If `ret_offset` is not NULL, it is set to the offset of the Data object
+         * - If `ret_data` is not NULL, it is set to a pointer to the decompressed payload of the Data object
+         * - If `ret_size` is not NULL, it is set to the size of the decompressed payload of the Data object
+         *
+         * The iterator is stored in `i`. To start iterating from the start of the entry items, set `i` to
+         * zero. It is automatically updated by this function and should not be touched again unless you want
+         * to restart iterating over the entry items.
+         *
+         * If `field` and `field_length` are given, this function keeps iterating until it finds an entry
+         * item whose Data object payload starts with the given field, followed by the '=' character.
+         *
+         * If `data_threshold` is larger than zero, the decompressed payload is limited to `data_threshold`
+         * amount of bytes.
+         *
+         * This function returns a positive number if it succesfully managed to find the next entry item. If
+         * no more entry items were available, or none of the remaining entry items were of the given field,
+         * it returns zero. If an error occurred, it returns a negative errno value.
+         */
+
+        int r;
+
+        assert(!e || e->object.type == OBJECT_ENTRY);
+        assert(offset);
+        assert(i);
+        assert(!field == (field_length == 0));
+
+        if (!e) {
+                r = journal_file_move_to_object(f, OBJECT_ENTRY, offset, &e);
+                if (r < 0)
+                        return r;
+        }
+
+        return JOURNAL_HEADER_COMPACT(f->header) ?
+                journal_file_entry_item_next_compact(
+                        f, e, offset, i, field, field_length, data_threshold, ret_offset, ret_data, ret_size) :
+                journal_file_entry_item_next_non_compact(
+                        f, e, offset, i, field, field_length, data_threshold, ret_offset, ret_data, ret_size);
+}
+
 uint64_t journal_file_entry_array_n_items(JournalFile *f, Object *o) {
         uint64_t sz;
 
@@ -1794,6 +2083,81 @@ uint64_t journal_file_hash_table_n_items(Object *o) {
         return (sz - offsetof(Object, hash_table.items)) / sizeof(HashItem);
 }
 
+static int journal_file_find_trie_object(
+                JournalFile *f,
+                uint64_t hash,
+                const EntryItemEx *items,
+                size_t n_items,
+                Object **ret,
+                uint64_t *ret_offset) {
+
+        uint64_t p, h, m, depth = 0;
+        int r;
+
+        assert(f);
+        assert(f->header);
+        assert(items);
+        assert(n_items > 0);
+
+        /* If there's no trie hash table, then there's no entry. */
+        if (le64toh(f->header->trie_hash_table_size) <= 0)
+                return 0;
+
+        /* Map the trie hash table, if it isn't mapped yet. */
+        r = journal_file_map_trie_hash_table(f);
+        if (r < 0)
+                return r;
+
+        m = le64toh(READ_NOW(f->header->trie_hash_table_size)) / sizeof(HashItem);
+        if (m <= 0)
+                return -EBADMSG;
+
+        h = hash % m;
+        p = le64toh(f->trie_hash_table[h].head_hash_offset);
+
+        while (p > 0) {
+                Object *o;
+
+                r = journal_file_move_to_object(f, OBJECT_TRIE_NODE, p, &o);
+                if (r < 0)
+                        return r;
+
+                if (le64toh(o->trie_node.hash) != hash)
+                        goto next;
+
+                uint64_t q = p;
+                Object *t = o;
+                size_t i = n_items - 1;
+
+                for (; i != SIZE_MAX && q != 0; i--, q = le32toh(t->trie_node.parent_offset)) {
+                        r = journal_file_move_to_object(f, OBJECT_TRIE_NODE, q, &t);
+                        if (r < 0)
+                                return r;
+
+                        if (le32toh(t->trie_node.object_offset) != items[i].object_offset)
+                                break;
+                }
+
+                if (i == SIZE_MAX && q == 0) {
+                        if (ret)
+                                *ret = o;
+
+                        if (ret_offset)
+                                *ret_offset = p;
+
+                        return 1;
+                }
+
+        next:
+                r = next_hash_offset(
+                        f, &p, &o->trie_node.next_hash_offset, &depth, &f->header->trie_hash_chain_depth);
+                if (r < 0)
+                        return r;
+        }
+
+        return 0;
+}
+
 static void write_entry_array_item(JournalFile *f, Object *o, uint64_t i, uint64_t p) {
         assert(f);
         assert(o);
@@ -1975,12 +2339,10 @@ static int journal_file_append_entry_internal(
                 JournalFile *f,
                 const dual_timestamp *ts,
                 const sd_id128_t *boot_id,
-                uint64_t xor_hash,
                 const EntryItemEx items[], size_t n_items,
                 uint64_t *seqnum,
                 Object **ret, uint64_t *ret_offset) {
-        uint64_t np;
-        uint64_t osize;
+        uint64_t np, osize, parent_offset = 0, xor_hash = 0;
         Object *o;
         int r;
 
@@ -1989,16 +2351,53 @@ static int journal_file_append_entry_internal(
         assert(items || n_items == 0);
         assert(ts);
 
-        osize = offsetof(Object, entry.items) + (n_items * sizeof(EntryItem));
+        for (uint64_t i = 0; i < n_items; i++)
+                xor_hash ^= items[i].xor_hash;
+
+        if (JOURNAL_HEADER_COMPACT(f->header)) {
+                size_t i;
+
+                for (i = n_items - 1; i != SIZE_MAX; i--) {
+                        r = journal_file_find_trie_object(f, xor_hash, items, i + 1, NULL, &parent_offset);
+                        if (r < 0)
+                                return r;
+                        if (r > 0)
+                                break;
+
+                        xor_hash ^= items[i].xor_hash; /* Remove hash from XOR hash. */
+                }
+
+                for (i += 1; i < n_items; i++) {
+                        uint64_t p;
+
+                        xor_hash ^= items[i].xor_hash; /* Add hash back to XOR hash. */
+
+                        r = journal_file_append_trie_node(
+                                f, xor_hash, parent_offset, items[i].object_offset, NULL, &p);
+                        if (r < 0)
+                                return r;
+
+                        parent_offset = p;
+                }
+        }
+
+        osize = JOURNAL_HEADER_COMPACT(f->header) ?
+                sizeof(EntryObject) :
+                offsetof(Object, entry.items) + (n_items * sizeof(EntryItem));
 
         r = journal_file_append_object(f, OBJECT_ENTRY, osize, &o, &np);
         if (r < 0)
                 return r;
 
         o->entry.seqnum = htole64(journal_file_entry_seqnum(f, seqnum));
-        for (size_t i = 0; i < n_items; i++)
-                o->entry.items[i] = (EntryItem){ .object_offset = htole64(items[i].object_offset),
-                                                 .hash = htole64(items[i].hash) };
+
+        if (JOURNAL_HEADER_COMPACT(f->header))
+                o->entry.trie_offset = htole64(parent_offset);
+        else
+                for (size_t i = 0; i < n_items; i++)
+                        o->entry.items[i] = (EntryItem){ .object_offset = htole64(items[i].object_offset),
+                                                         .hash = htole64(items[i].hash) };
+
         o->entry.realtime = htole64(ts->realtime);
         o->entry.monotonic = htole64(ts->monotonic);
         o->entry.xor_hash = htole64(xor_hash);
@@ -2133,9 +2532,8 @@ int journal_file_append_entry(
                 Object **ret, uint64_t *ret_offset) {
 
         EntryItemEx *items;
-        int r;
-        uint64_t xor_hash = 0;
         struct dual_timestamp _ts;
+        int r;
 
         assert(f);
         assert(f->header);
@@ -2180,14 +2578,12 @@ int journal_file_append_entry(
                  * are completely identical (they include the XOR hash after all). For classic Jenkins-hash
                  * files things are easier, we can just take the value from the stored record directly. */
 
-                if (JOURNAL_HEADER_KEYED_HASH(f->header))
-                        xor_hash ^= jenkins_hash64(iovec[i].iov_base, iovec[i].iov_len);
-                else
-                        xor_hash ^= le64toh(o->data.hash);
-
-                items[i] = (EntryItemEx) {
+                items[i] = (EntryItemEx){
                         .object_offset = p,
                         .hash = le64toh(o->data.hash),
+                        .xor_hash = JOURNAL_HEADER_KEYED_HASH(f->header) ?
+                                jenkins_hash64(iovec[i].iov_base, iovec[i].iov_len) :
+                                le64toh(o->data.hash),
                 };
         }
 
@@ -2196,7 +2592,7 @@ int journal_file_append_entry(
         typesafe_qsort(items, n_iovec, entry_item_cmp);
         n_iovec = remove_duplicate_entry_items(items, n_iovec);
 
-        r = journal_file_append_entry_internal(f, ts, boot_id, xor_hash, items, n_iovec, seqnum, ret, ret_offset);
+        r = journal_file_append_entry_internal(f, ts, boot_id, items, n_iovec, seqnum, ret, ret_offset);
 
         /* If the memory mapping triggered a SIGBUS then we return an
          * IO error and ignore the error code passed down to us, since
@@ -3275,6 +3671,7 @@ void journal_file_print_header(JournalFile *f) {
                "Arena size: %"PRIu64"\n"
                "Data hash table size: %"PRIu64"\n"
                "Field hash table size: %"PRIu64"\n"
+               "Trie hash table size: %"PRIu64"\n"
                "Rotate suggested: %s\n"
                "Head sequential number: %"PRIu64" (%"PRIx64")\n"
                "Tail sequential number: %"PRIu64" (%"PRIx64")\n"
@@ -3303,6 +3700,7 @@ void journal_file_print_header(JournalFile *f) {
                le64toh(f->header->arena_size),
                le64toh(f->header->data_hash_table_size) / sizeof(HashItem),
                le64toh(f->header->field_hash_table_size) / sizeof(HashItem),
+               le64toh(f->header->trie_hash_table_size) / sizeof(HashItem),
                yes_no(journal_file_rotate_suggested(f, 0, LOG_DEBUG)),
                le64toh(f->header->head_entry_seqnum), le64toh(f->header->head_entry_seqnum),
                le64toh(f->header->tail_entry_seqnum), le64toh(f->header->tail_entry_seqnum),
@@ -3324,6 +3722,12 @@ void journal_file_print_header(JournalFile *f) {
                        le64toh(f->header->n_fields),
                        100.0 * (double) le64toh(f->header->n_fields) / ((double) (le64toh(f->header->field_hash_table_size) / sizeof(HashItem))));
 
+        if (JOURNAL_HEADER_CONTAINS(f->header, n_trie_nodes))
+                printf("Trie Node objects: %"PRIu64"\n"
+                       "Trie Node hash table fill: %.1f%%\n",
+                       le64toh(f->header->n_trie_nodes),
+                       100.0 * (double) le64toh(f->header->n_trie_nodes) / ((double) (le64toh(f->header->trie_hash_table_size) / sizeof(HashItem))));
+
         if (JOURNAL_HEADER_CONTAINS(f->header, n_tags))
                 printf("Tag objects: %"PRIu64"\n",
                        le64toh(f->header->n_tags));
@@ -3339,6 +3743,10 @@ void journal_file_print_header(JournalFile *f) {
                 printf("Deepest data hash chain: %" PRIu64"\n",
                        f->header->data_hash_chain_depth);
 
+        if (JOURNAL_HEADER_CONTAINS(f->header, trie_hash_chain_depth))
+                printf("Deepest trie hash chain: %" PRIu64"\n",
+                       f->header->trie_hash_chain_depth);
+
         if (fstat(f->fd, &st) >= 0)
                 printf("Disk usage: %s\n", FORMAT_BYTES((uint64_t) st.st_blocks * 512ULL));
 }
@@ -3611,6 +4019,12 @@ int journal_file_open(
                 if (r < 0)
                         goto fail;
 
+                if (JOURNAL_HEADER_COMPACT(f->header)) {
+                        r = journal_file_setup_trie_hash_table(f);
+                        if (r < 0)
+                                goto fail;
+                }
+
 #if HAVE_GCRYPT
                 r = journal_file_append_first_tag(f);
                 if (r < 0)
@@ -3722,7 +4136,7 @@ int journal_file_dispose(int dir_fd, const char *fname) {
 }
 
 int journal_file_copy_entry(JournalFile *from, JournalFile *to, Object *o, uint64_t p) {
-        size_t n = 0, xor_hash = 0;
+        size_t n = 0;
         const sd_id128_t *boot_id;
         dual_timestamp ts;
         EntryItemEx *items;
